function [f, df] = fun(x, dim, C, X, scores, classifier, objective, grad_W, grad_b)
%FUN Summary of this function goes here
%   Detailed explanation goes here

    W = reshape(x(1:dim*C), dim, C);
    b = reshape(x(dim*C+1:end), 1, C);

    scores_train = scores(classifier(W, b, X));
    f = objective(W, b);
    
    if nargout > 1
        dW = zeros(dim, C);
        db = zeros(1, C);
        for j=1:C   
            dW(:, j) = grad_W(W, scores_train, j);
            db(j) = grad_b(b, scores_train, j);
        end    
        df = [dW(:);db(:)];
    end
end

